%define  patch_name kernel-fix-fs

Name: %patch_name
Version: 2006.10.24
Release: alt2

Summary: %patch_name kernel patch - general fixes for filesystem drivers
License: GPL
Group: Development/Kernel
Packager: Kernel Maintainers Team <kernel@packages.altlinux.org>

Conflicts: kernel-fix-security-owl < 2004.06.20-alt1

# 2.4 patches

%source  1	2.4_01_ext3_fs_priority.patch			2.4
%source  2	2.4_02_iocharset-ign.patch			2.4
%source  3	2.4_03_quota-license.patch			2.4
%source  4	2.4_04_dcache-nr_unused-race.patch		2.4
%source 16	2.4_16_alt-ramfs-blocks.patch			2.4
%source 40	2.4_40_quota_v1-module.patch			2.4
%source 41	2.4_41_proc-ndynamic.patch			2.4

# kernel 2.6 patches

%source 2608	2.6_08_proc-devices-duplicate.patch			2.6
%source 2609	2.6_09_xfs-writeout-fix.patch				2.6
%source 2610	2.6_10_v9fs-assign-dentry-ops.patch			2.6
%source 2611	2.6_11_knfsd-reserved-reply-space.patch			2.6
%source 2612	2.6_12_proc-vmcore-size-overflow.patch			2.6
%source 2613	2.6_13_fuse_send_readpages-oops.patch			2.6
%source 2614	2.6_14_fix-block-device-symlink-name.patch		2.6
%source 2615	2.6_15_ext3-fix-missed-mutex-unlock.patch		2.6
%source 2616	2.6_16_xfs-utime-no-times-parameter.patch		2.6
%source 2617	2.6_17_cifs-smb-read-signature.patch			2.6
%source 2618	2.6_18_no-tail-call-sys_ftruncate.patch			2.6
%source 2619	2.6_19_no-tail-call-sys_open.patch			2.6
%source 2620	2.6_20_fix-file-lookup-without-ref.patch		2.6
%source 2621	2.6_21_proc-devices-fix.patch				2.6
%source 2622	2.6_22_reiserfs-deadlock.patch				2.6
%source 2623	2.6_23_lsm-do_compat_readv_writev.patch			2.6
%source 2624	2.6_24_sys_flock-race.patch				2.6
%source 2625	2.6_25-tmpfs-shmem_rmdir-i_nlink-fix.patch		2.6
%source 2626	2.6_26_smbfs-slab-corruption.patch			2.6
%source 2627	2.6_27_compat_sys_ppoll-typo.patch			2.6
%source 2628	2.6_28_tmpfs-time-granularity-fix.patch			2.6
%source 2629	2.6_29_open_namei-intent-error-check.patch		2.6
%source 2630	2.6_30_do_lookup_path-locking.patch			2.6
%source 2631	2.6_31_jfs-metapage_releasepage.patch			2.6
%source 2632	2.6_32_ntfs-flush_dcache_page.patch			2.6
%source 2633	2.6_33___bio_map_user-error-path.patch			2.6
%source 2634	2.6_34_debugfs-inode-leak.patch				2.6
%source 2635	2.6_35_struct-file-leak.patch				2.6
%source 2636	2.6_36_fix-fdset-leakage.patch				2.6/not_kernel-feat-core-openvz
%source 2637	2.6_37_cifs-null-deref.patch				2.6
%source 2638	2.6_38_cifs-unlink-oops.patch				2.6
%source 2639	2.6_39_cifs-unlink-null-check.patch			2.6
%source 2340	2.6_40_cifs-suspend-fix.patch				2.6

%source 2650	2.6_50_ext3_fs_priority.patch				2.6

BuildArch: noarch
BuildRequires: kernel-build-tools

%description
General fixes for filesystem drivers

%install
%install_patches

%files
%_usrsrc/*

%changelog
* Wed Oct 25 2006 L.A. Kostis <lakostis@altlinux.org> 2006.10.24-alt2
- Don't apply already applied 2.6_36_fix-fdset-leakage.patch for OpenVZ build.

* Tue Oct 24 2006 Sergey Vlasov <vsu@altlinux.ru> 2006.10.24-alt1
- Added patches for 2.6.16:
  + 2.6_36_fix-fdset-leakage.patch: fix fdset leakage due to freeing fdsets of
    wrong size
  + 2.6_37_cifs-null-deref.patch: cifs: fix possible NULL dereference
  + 2.6_38_cifs-unlink-oops.patch: cifs: fix unlink oops in rename error path
  + 2.6_39_cifs-unlink-null-check.patch: cifs: add another NULL check in the
    unlink path
  + 2.6_40_cifs-suspend-fix.patch: cifs: allow cifsd to suspend if connection
    is lost

* Sun Sep 03 2006 Sergey Vlasov <vsu@altlinux.ru> 2006.09.03-alt1
- Added patches for 2.6.16:
  + 2.6_33___bio_map_user-error-path.patch: fix missing ret assignment in
    __bio_map_user() error path
  + 2.6_34_debugfs-inode-leak.patch: debugfs: fix inode leak
  + 2.6_35_struct-file-leak.patch: fs/namei.c: fix struct file leak due to
    unreleased open intent data

* Fri Jul 07 2006 Sergey Vlasov <vsu@altlinux.ru> 2006.07.07-alt1
- Added patches for 2.6.16:
  + 2.6_29_open_namei-intent-error-check.patch: add missing error checking for
    intent's filp in open_namei()
  + 2.6_30_do_lookup_path-locking.patch: fix call to file_permission() under a
    spinlock in do_lookup_path()
  + 2.6_31_jfs-metapage_releasepage.patch: jfs: fix multiple errors in
    metapage_releasepage
  + 2.6_32_ntfs-flush_dcache_page.patch: ntfs: fix broken code calling
    flush_dcache_page() (really a noop on i386)

* Fri Jun 16 2006 Sergey Vlasov <vsu@altlinux.ru> 2006.06.16-alt1
- Added patches for 2.6.16:
  + 2.6_28_tmpfs-time-granularity-fix.patch: tmpfs: time granularity fix for
    inode times going backwards

* Fri May 19 2006 Sergey Vlasov <vsu@altlinux.ru> 2006.05.19-alt1
- Added patches for 2.6.16:
  + 2.6_24_sys_flock-race.patch: fix sys_flock() race which could result in
    double free
  + 2.6_25-tmpfs-shmem_rmdir-i_nlink-fix.patch: tmpfs: decrement i_nlink
    correctly in shmem_rmdir()
  + 2.6_26_smbfs-slab-corruption.patch: smbfs: fix slab corruption in samba
    error path
  + 2.6_27_compat_sys_ppoll-typo.patch: fix typo in compat_sys_ppoll()
- Removed obsolete patches for kernel 2.6.14:
  - 2.6_00_fix-memory-leak-with-file-leases.patch
  - 2.6_01_xfs-modular-quota-build-fix.patch
  - 2.6_02_xfs-umount-lockup.patch
  - 2.6_03_listxattr-generic-security-attributes.patch
  - 2.6_04_ufs-i_sem-error-path.patch
  - 2.6_05_ufs-mount-oops.patch
  - 2.6_06_reiserfs-mount-options.patch
  - 2.6_07_d_instantiate_unique-nfs-inode-leak.patch

* Sat Apr 29 2006 Sergey Vlasov <vsu@altlinux.ru> 2006.04.29-alt1
- Added patches for 2.6.16:
  + 2.6_21_proc-devices-fix.patch: simplify /proc/devices and fix early
    termination regression
  + 2.6_22_reiserfs-deadlock.patch: reiserfs: fix acl-related deadlock
  + 2.6_23_lsm-do_compat_readv_writev.patch: LSM: add missing hook to
    do_compat_readv_writev()

* Sun Apr 23 2006 Sergey Vlasov <vsu@altlinux.ru> 2006.04.23-alt1
- Added patches for 2.6.16:
  + 2.6_13_fuse_send_readpages-oops.patch: fuse: fix oops in
    fuse_send_readpages()
  + 2.6_14_fix-block-device-symlink-name.patch: fix block device symlink name
    for devices with a '/' in their name
  + 2.6_15_ext3-fix-missed-mutex-unlock.patch: ext3: fix missed mutex unlock in
    error path
  + 2.6_16_xfs-utime-no-times-parameter.patch: xfs: fix utime(2) in the case
    that no times parameter was passed in
  + 2.6_17_cifs-smb-read-signature.patch: cifs: fix incorrect signature sent on
    SMB Read (Samba bug 3621, kernel.org bug 6147)
  + 2.6_18_no-tail-call-sys_ftruncate.patch: x86: don't allow tail-calls in
    sys_ftruncate[64]() to avoid userspace register corruption
  + 2.6_19_no-tail-call-sys_open.patch: x86: be careful about tailcall breakage
    for sys_open[at] too
  + 2.6_20_fix-file-lookup-without-ref.patch: fix file lookup without ref

* Wed Apr 12 2006 Sergey Vlasov <vsu@altlinux.ru> 2006.04.12-alt1
- Added patches for 2.6.16:
  + 2.6_11_knfsd-reserved-reply-space.patch: knfsd: correct reserved reply
    space for read requests
  + 2.6_12_proc-vmcore-size-overflow.patch: kdump proc vmcore size overflow fix

* Sat Mar 25 2006 Sergey Vlasov <vsu@altlinux.ru> 2006.03.25-alt1
- Updated for kernel 2.6.16.
- Marked old patches to be applied only for 2.6.14:
  - 2.6_00_fix-memory-leak-with-file-leases.patch
  - 2.6_01_xfs-modular-quota-build-fix.patch
  - 2.6_02_xfs-umount-lockup.patch
  - 2.6_03_listxattr-generic-security-attributes.patch
  - 2.6_04_ufs-i_sem-error-path.patch
  - 2.6_05_ufs-mount-oops.patch
  - 2.6_06_reiserfs-mount-options.patch
  - 2.6_07_d_instantiate_unique-nfs-inode-leak.patch
- Added patches for 2.6.16:
  + 2.6_08_proc-devices-duplicate.patch: fix duplicated line in /proc/devices
  + 2.6_09_xfs-writeout-fix.patch: xfs: avoid writeout of clean data
  + 2.6_10_v9fs-assign-dentry-ops.patch: v9fs: assign dentry ops to negative
    dentries

* Thu Feb 09 2006 Sergey Vlasov <vsu@altlinux.ru> 2006.02.09-alt1
- Added patches for 2.6.14:
  + 2.6_07_d_instantiate_unique-nfs-inode-leak.patch: fix NFS inode leak when
    d_instantiate_unique finds aliased dentry

* Tue Feb 07 2006 Sergey Vlasov <vsu@altlinux.ru> 2006.02.07-alt1
- Added patches for 2.6.14:
  + 2.6_05_ufs-mount-oops.patch: ufs: fix oops on mount
  + 2.6_06_reiserfs-mount-options.patch: reiserfs: fix mount options parsing

* Sat Jan 07 2006 Sergey Vlasov <vsu@altlinux.ru> 2006.01.07-alt1
- Added patches for 2.6.14:
  + 2.6_03_listxattr-generic-security-attributes.patch: fix listxattr() for
    generic security attributes
  + 2.6_04_ufs-i_sem-error-path.patch: ufs: inode->i_sem is not released in
    error path

* Sun Dec 25 2005 Sergey Vlasov <vsu@altlinux.ru> 2005.12.25-alt1
- Updated for kernel 2.4.32.
- Removed obsolete patches:
  - 2.4_15_alt-iso9660-options.patch
- Added:
  + 2.4_04_dcache-nr_unused-race.patch: dcache: avoid race when updating
    nr_unused count of unused dentries

* Sun Dec 04 2005 Sergey Vlasov <vsu@altlinux.ru> 2005.12.04-alt1
- Added patches for 2.6.14:
  + 2.6_02_xfs-umount-lockup.patch: fix umount/xfslogd deadlock

* Wed Nov 30 2005 Sergey Vlasov <vsu@altlinux.ru> 2005.11.30-alt1
- Updated for kernel 2.6.14.
- Removed obsolete patches:
  - 2.6_00_unregister_chrdev_region-semaphore-fix.patch
  - 2.6_01_bio_clone-fix.patch
  - 2.6_02_zisofs.patch
- Added:
  - 2.6_00_fix-memory-leak-with-file-leases.patch: VFS: fix memory leak with
    file leases
  - 2.6_01_xfs-modular-quota-build-fix.patch: fix XFS_QUOTA for modular XFS

* Sun Aug 14 2005 Sergey Vlasov <vsu@altlinux.ru> 2005.08.14-alt1
- Added:
  + 2.6_01_bio_clone-fix.patch: fix BIO cloning bug which could result
    in data corruption with some MD setups
  + 2.6_02_zisofs.patch: check input buffer size in zisofs

* Mon Jul 25 2005 Sergey Vlasov <vsu@altlinux.ru> 2005.07.25-alt1
- Added:
  + 2.6_00_unregister_chrdev_region-semaphore-fix.patch: fix locking in
    __unregister_chrdev_region()

* Sat Jul 02 2005 Sergey Vlasov <vsu@altlinux.ru> 2005.07.02-alt1
- Updated for kernel 2.6.12.
- Removed obsolete patches:
  - 2.6_00_cramfs-stat-fix.patch
  - 2.6_01_jbd-race.patch
  - 2.6_02_ext3-fix-race.patch
  - 2.6_03_fix-log_do_checkpoint-assertion-failure.patch
  - 2.6_04_hfsplus-oops-hfs-leak-fix.patch

* Mon Jun 13 2005 Sergey Vlasov <vsu@altlinux.ru> 2005.06.13-alt1
- Added patches for 2.6:
  + 2.6_03_fix-log_do_checkpoint-assertion-failure.patch: ext3: fix possible
    false assertion failure in log_do_checkpoint()
  + 2.6_04_hfsplus-oops-hfs-leak-fix.patch: fix hfsplus oops, hfs and hfsplus
    leak

* Fri May 13 2005 Sergey Vlasov <vsu@altlinux.ru> 2005.05.13-alt1
- Added patches for 2.6:
  + 2.6_02_ext3-fix-race.patch: fix race between ext3 make block reservation
    and reservation window discard

* Tue May 10 2005 Sergey Vlasov <vsu@altlinux.ru> 2005.05.10-alt1
- Added patches for 2.6:
  + 2.6_01_jbd-race.patch: fix race in jbd code which could give oopses

* Mon Mar 14 2005 Sergey Vlasov <vsu@altlinux.ru> 2005.03.14-alt1
- Updated for kernel 2.6.11.
- Removed obsolete patches:
  - 2.6_00_023-nfs_dentry_refcount.patch
  - 2.6_00_024-nfs_incorrect_df_output.patch
  - 2.6_00_026-nfs_o_direct_error.patch
  - 2.6_00_052-vfat_valid_longname_proper_return.patch
  - 2.6_00_054-ext3_journal_abort_before_panic.patch
  - 2.6_00_077-ext3_journal_abort_handle_silence.patch
  - 2.6_00_078-jbd_journal_revoke_graceful_double_delete.patch
  - 2.6_00_087-ext3_graceful_corruption_fixes.patch
  - 2.6_10_nls_ascii-fix.patch
- Added:
  + 2.6_00_cramfs-stat-fix.patch: fix stat for device nodes on cramfs

* Wed Feb 09 2005 Sergey Vlasov <vsu@altlinux.ru> 2005.02.09-alt1
- Added patches from 2.6.10-as3:
  + 2.6_00_023-nfs_dentry_refcount.patch
  + 2.6_00_024-nfs_incorrect_df_output.patch
  + 2.6_00_026-nfs_o_direct_error.patch
  + 2.6_00_052-vfat_valid_longname_proper_return.patch
  + 2.6_00_054-ext3_journal_abort_before_panic.patch
  + 2.6_00_077-ext3_journal_abort_handle_silence.patch
  + 2.6_00_078-jbd_journal_revoke_graceful_double_delete.patch
  + 2.6_00_087-ext3_graceful_corruption_fixes.patch
- Added:
  + 2.6_10_nls_ascii-fix.patch: fix nls_ascii conversion table

* Sun Oct 17 2004 Sergey Vlasov <vsu@altlinux.ru> 2004.10.17-alt1
- Updated for kernel 2.4.27.
- Removed obsolete patches:
   - 2.4_17_proc-put_files_struct.patch
   - 2.4_18_dquot-sync-too-slow.patch
   - 2.4_19_ext2-mount-sb-fix.patch
   - 2.4_20_devpts-error-leak.patch
- Added:
  + 2.4_41_proc-ndynamic.patch: increase limit for dynamic /proc entries (4096
    is too easy to exceed, e.g. with vconfig (Bug #5296))

* Wed Jun 23 2004 Anton Farygin <rider@altlinux.ru> 2004.06.22-alt1
- removed included to mainstream (2.6.7) patches

* Sun Jun 20 2004 Sergey Vlasov <vsu@altlinux.ru> 2004.06.20-alt1
- Apply 2.4_17_proc-put_files_struct.patch only when kernel-fix-security-owl is
  not applied.

* Sun May 23 2004 Sergey Vlasov <vsu@altlinux.ru> 2004.05.23-alt1
- Updated:
  + 2.4_03_quota-license.patch: add missing MODULE_LICENSE to quota_v1

* Fri May 21 2004 Sergey Vlasov <vsu@altlinux.ru> 2004.05.21-alt1
- Added:
  + 2.6_55_reiserfs-i_size-race.patch: fix reiserfs inode size update race
    which could lead to file corruption

* Tue May 18 2004 Sergey Vlasov <vsu@altlinux.ru> 2004.05.18-alt1
- Added:
  + 2.6_51_dquot_release-oops.patch: fix dquot_release oops with quota_v1
  + 2.6_52_quota-recursion.patch: fixes quota recursion into filesystem
  + 2.6_53_quota-recursion-fix.patch: fix the recursion fix
  + 2.6_54_quota-v2-corruption.diff: fix possible quota_v2 files corruption
    when root did not have any inodes&space allocated

* Mon May 17 2004 Sergey Vlasov <vsu@altlinux.ru> 2004.05.17-alt1
- Added:
  + 2.4_40_quota_v1-module.patch: build old quota format support as module to
    match old quota patches and current 2.6.x

* Mon May 10 2004 Sergey Vlasov <vsu@altlinux.ru> 2004.05.10-alt1
- Updated for kernel 2.4.26.
- Removed obsolete patches:
  - 2.4_17_posix-locks-oops.patch
  - 2.4_18_refile_inode-locked.patch
- Added:
  + 2.4_17_proc-put_files_struct.patch: fix potential memory access to free
    memory in /proc handling
  + 2.4_18_dquot-sync-too-slow.patch: fix O(N^2) dquot sync behaviour
  + 2.4_19_ext2-mount-sb-fix.patch: ext2 sb= mount option fix
  + 2.4_20_devpts-error-leak.patch: fix memory leak in devpts on error path

* Sat Apr 03 2004 Sergey Vlasov <vsu@altlinux.ru> 2004.04.03-alt1
- Added:
  + 2.4_18_refile_inode-locked.patch: avoid refile_inode() from putting locked
    inodes on the dirty list (http://bugme.osdl.org/show_bug.cgi?id=2367)

* Thu Mar 18 2004 Sergey Vlasov <vsu@altlinux.ru> 2004.03.18-alt1
- Added:
  + 2.4_17_posix-locks-oops.patch: fix oops in locks_remove_posix()

* Sat Mar 06 2004 Sergey Vlasov <vsu@altlinux.ru> 2004.03.06-alt1
- Modified:
  - 2.4_02_iocharset-ign.patch: fixed reiserfs part to make it really work

* Sun Feb 29 2004 Sergey Vlasov <vsu@altlinux.ru> 2004.02.29-alt1
- Added:
  + 2.4_16_alt-ramfs-blocks.patch: fix st_blocks==0 on ramfs (#3612)

* Thu Feb 26 2004 Sergey Vlasov <vsu@altlinux.ru> 2004.02.26-alt1
- Modified:
  - 2.4_02_iocharset-ign.patch: move reiserfs modifications to avoid conflict
    with reiserfs quota patches

* Mon Feb 23 2004 Sergey Vlasov <vsu@altlinux.ru> 2004.02.23-alt1
- Updated for kernel 2.4.25.
- Removed obsolete patches (merged upstream):
  - 2.4_04_block_read_full_page.patch
  - 2.4_05_inodes_stat-locking.patch
  - 2.4_06_kupdated-sigstop-fix.patch
  - 2.4_07_do_proc_readlink-leak.patch
  - 2.4_08_quota_v1-overflow.patch
  - 2.4_09_exec_mmap-race.patch
  - 2.4_10_nfs-async-deadlock.patch
  - 2.4_11_lockd-deadlock.patch
  - 2.4_12_minix-corruption.patch
  - 2.4_13_dquot-stats.patch
  - 2.4_16_remove-flock-accounting.patch
  - 2.4_17_end_buffer_io_kiobuf-locking.patch
  - 2.4_18_fsync-race.patch
  - 2.4_19_dcache-seekdir-oops.patch
  - 2.4_20_ext3-quota-deadlock.patch
  - 2.4_21_tmpfs-readdir-atime.patch
  - 2.4_22_hfs-oops.patch
  - 2.4_23_mount-options-overrun.patch

* Tue Feb 10 2004 Anton Farygin <rider@altlinux.ru> 2004.02.01-alt2
- Added:
    + 2.6_50_ext3_fs_priority.patch: move up ext3 in filesystem list
    for correct mount ext3 fs, if ext2 compiled into kernel image

* Sun Feb 01 2004 Sergey Vlasov <vsu@altlinux.ru> 2004.02.01-alt1
- Added:
  + 23_mount-options-overrun.patch: Avoid buffer overrun in mount options
    parsing.

* Sun Jan 25 2004 Sergey Vlasov <vsu@altlinux.ru> 2004.01.25-alt1
- Added:
  + 19_dcache-seekdir-oops.patch: Fix tmpfs seekdir oops.
  + 20_ext3-quota-deadlock.patch: Fix ext3 quota deadlock.
  + 21_tmpfs-readdir-atime.patch: Make tmpfs readdir update atime.
  + 22_hfs-oops.patch: Fix hfs oops with non-512 byte sectors (CD-ROM).
- Removed:
  + 14_inode-hash-race-fix.patch (can cause deadlock on SMP).

* Mon Dec 15 2003 Sergey Vlasov <vsu@altlinux.ru> 2003.12.15-alt1
- Added:
  + 16_remove-flock-accounting.patch: Remove broken file lock
    accounting.
  + 17_end_buffer_io_kiobuf-locking.patch: Fix end_buffer_io_kiobuf()
    locking.
  + 18_fsync-race.patch: Fix potential fsync() race condition.

* Fri Nov 21 2003 Sergey Vlasov <vsu@altlinux.ru> 2003.11.21-alt1
- Added:
  + 15_alt-iso9660-options.patch: Fix iso9660 mount options handling (all
    options after iocharset/map/session were silently ignored).

* Tue Nov 18 2003 Sergey Vlasov <vsu@altlinux.ru> 2003.11.18-alt1
- Added:
  + 13_dquot-stats.patch: Fix quota stats accounting bug.
  + 14_inode-hash-race-fix.patch: Fix races between deleting inode (through
    iput() or prune_icache()) and getting the same inode through iget().

* Thu Nov 06 2003 Sergey Vlasov <vsu@altlinux.ru> 2003.11.06-alt1
- Added:
  + 05_inodes_stat-locking.patch
  + 06_kupdated-sigstop-fix.patch
  + 07_do_proc_readlink-leak.patch
  + 08_quota_v1-overflow.patch
  + 09_exec_mmap-race.patch
  + 10_nfs-async-deadlock.patch
  + 11_lockd-deadlock.patch
  + 12_minix-corruption.patch

* Sun Oct 26 2003 Sergey Vlasov <vsu@altlinux.ru> 2003.10.26-alt1
- Renamed patch files (added numeric prefixes to enforce apply ordering).
- Added 04_block_read_full_page.patch - Handle get_block errors correctly in
  block_read_full_page().

* Tue Sep 16 2003 Sergey Vlasov <vsu@altlinux.ru> 2003.09.16-alt1
- added quota-license.patch: add MODULE_LICENSE("GPL") to quota_v2.

* Tue Jul 15 2003 Peter Novodvorsky <nidd@altlinux.com> 2003.07.15-alt1
- added patch that puts ext3 before ext2 filesystem list, so that ext3 probed
  first.

* Tue Jul 08 2003 Peter Novodvorsky <nidd@altlinux.com> 2003.07.08-alt1
- initial release.

